// -----------------------------------------------------------------------
// MatchPoint - DKFZ translational registration framework
//
// Copyright (c) German Cancer Research Center (DKFZ),
// Software development for Integrated Diagnostics and Therapy (SIDT).
// ALL RIGHTS RESERVED.
// See mapCopyright.txt or
// http://www.dkfz.de/en/sidt/projects/MatchPoint/copyright.html
//
// This software is distributed WITHOUT ANY WARRANTY; without even
// the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
// PURPOSE.  See the above copyright notices for more information.
//
//------------------------------------------------------------------------
/*!
// @file
// @version $Revision: 1316 $ (last changed revision)
// @date    $Date: 2016-04-13 14:50:09 +0200 (Mi, 13 Apr 2016) $ (last change date)
// @author  $Author: floca $ (last changed by)
// Subversion HeadURL: $HeadURL: https://svn/sbr/Sources/SBR-Projects/MatchPoint/trunk/Code/Core/test/mapInvertingRegistrationKernelTest.cpp $
*/

#if defined(_MSC_VER)
#pragma warning ( disable : 4786 )
#endif

#include "mapInvertingRegistrationKernel.h"
#include "litCheckMacros.h"
#include "mapPreCachedRegistrationKernel.h"

namespace map
{
	namespace testing
	{

		int mapInvertingRegistrationKernelTest(int, char* [])
		{
			PREPARE_DEFAULT_TEST_REPORTING;

			typedef core::InvertingRegistrationKernel<3, 2> KernelType;
			typedef core::PreCachedRegistrationKernel<2, 3> SourcelKernelType;

			SourcelKernelType::Pointer spSourceKernel = SourcelKernelType::New();
			KernelType::Pointer spKernel = KernelType::New();

			//just check the additions to the "normal" lazy field kernel

			CHECK(spKernel->getSourceKernel() == NULL); //default must be null

			CHECK_NO_THROW(spKernel->setSourceKernel(spSourceKernel));

			CHECK(spKernel->getSourceKernel() == spSourceKernel.GetPointer());

			RETURN_AND_REPORT_TEST_SUCCESS;
		}
	} //namespace testing
} //namespace map
